package com.sample.chat;

import java.util.Collection;
import java.util.ArrayList;

import org.directwebremoting.WebContext;
import org.directwebremoting.WebContextFactory;
import org.directwebremoting.annotations.*;
import org.directwebremoting.proxy.dwr.Util;

@RemoteProxy(scope=ScriptScope.APPLICATION)
public class JavaChat {
	private ArrayList<String> messages = new ArrayList<String>();
	
	@RemoteMethod
	public void addMessage(String nm, String txt) {
		if (nm.trim().length() == 0) {
			nm = "";
		}
		if (txt.trim().length() > 0) {
			messages.add(nm + ": " + txt);
			while (messages.size() > 10) {
				messages.remove(0);
			}
		}
		
		WebContext wctx = WebContextFactory.get();
		String currentPage = wctx.getCurrentPage();
		
		Collection sessions = wctx.getScriptSessionsByPage(currentPage);
		Util utilAll = new Util(sessions);
		utilAll.removeAllOptions("chatlog");
		utilAll.addOptions("chatlog", messages.toArray(new String[]{}));
	}
}
