package com.sample.chat;

import java.util.Collection;
import java.util.ArrayList;
import java.util.Iterator;

import org.directwebremoting.ScriptBuffer;
import org.directwebremoting.ScriptSession;
import org.directwebremoting.WebContext;
import org.directwebremoting.WebContextFactory;
import org.directwebremoting.annotations.*;
import org.directwebremoting.proxy.dwr.Util;

@RemoteProxy(scope=ScriptScope.APPLICATION)
public class JsChat {
	private ArrayList<String> messages = new ArrayList<String>();
	
	@RemoteMethod
	public void addMessage(String nm, String txt) {
		if (nm.trim().length() == 0) {
			nm = "";
		}
		if (txt.trim().length() > 0) {
			messages.add(nm + ": " + txt);
			while (messages.size() > 10) {
				messages.remove(0);
			}
		}
		
		WebContext wctx = WebContextFactory.get();
		String currentPage = wctx.getCurrentPage();
		
        ScriptBuffer script = new ScriptBuffer();
        script.appendScript("receiveMessages(")
              .appendData(messages)
              .appendScript(");");

        // Loop over all the users on the current page
        Collection<ScriptSession> pages = wctx.getScriptSessionsByPage(currentPage);
        for (ScriptSession otherSession : pages) {
            otherSession.addScript(script);
        }		
	}
}
